package com.sky.controller.admin;

import com.aliyun.oss.ClientException;
import com.aliyun.oss.OSS;
import com.aliyun.oss.OSSClientBuilder;
import com.aliyun.oss.OSSException;
import com.aliyun.oss.common.auth.CredentialsProviderFactory;
import com.aliyun.oss.common.auth.EnvironmentVariableCredentialsProvider;

import java.io.ByteArrayInputStream;

import com.aliyun.oss.OSS;
import com.aliyun.oss.OSSClientBuilder;
import com.aliyun.oss.OSSException;
import com.aliyun.oss.common.auth.CredentialsProviderFactory;
import com.aliyun.oss.common.auth.EnvironmentVariableCredentialsProvider;
import com.sky.constant.JwtClaimsConstant;
import com.sky.dto.EmployeeLoginDTO;
import com.sky.entity.Employee;
import com.sky.entity.landimg;
import com.sky.properties.JwtProperties;
import com.sky.result.Result;
import com.sky.service.EmployeeService;
import com.sky.utils.AliOssUtil;
import com.sky.utils.JwtUtil;
import com.sky.vo.EmployeeLoginVO;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.core.io.Resource;
import org.springframework.core.io.UrlResource;
import org.springframework.http.HttpHeaders;
import org.springframework.http.MediaType;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.servlet.support.ServletUriComponentsBuilder;

import java.io.ByteArrayInputStream;
import java.io.File;
import java.io.IOException;
import java.net.MalformedURLException;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.UUID;
/**
 * @Author zhangyifan
 * @Date 2024/4/11 15:12
 */

/**
 * 员工管理
 */
@RestController
@RequestMapping("/admin/employee")
@Slf4j
public class EmployeeController {
    public String FilePath;

    @Autowired
    private EmployeeService employeeService;
    @Autowired
    private JwtProperties jwtProperties;
    @Autowired
    private AliOssUtil aliOssUtil;


    /**
     * 根据当前位置经纬度获取距离最近的三个位置
     *
     * @param volatitude
     * @param volongitude
     * @return
     */
    @GetMapping("/location")
    public Result<List<Employee>> getlocation(@RequestParam double volatitude, @RequestParam double volongitude) {

        return Result.success(employeeService.getlocation(volatitude, volongitude));

    }

    /**
     * 上传表单信息
     *
     * @return
     */
    @PostMapping("/getLandImg")
    public Result<String> getLandImg(@RequestBody landimg landimg) {
        System.out.println("这是site: " + landimg.getSite() + " author: " + landimg.getAuthor());
        employeeService.postform(landimg.getAuthor(), landimg.getSite(), landimg.getPzdt(), landimg.getImgurl());
        return Result.success();
    }

    /*图片的上传*/
    @PostMapping("/geturl")
    public Result uploadPhoto(@RequestParam("photo") MultipartFile photo) throws IOException {
//        System.out.println("photo" + photo);
        try {
            String originalFilename = photo.getOriginalFilename();
            String extension = originalFilename.substring(originalFilename.lastIndexOf("."));
            String objectName = UUID.randomUUID().toString() + extension;
            String fileUrl = aliOssUtil.upload(photo.getBytes(), objectName);
            String FileVO = "https://aielab-zht.oss-cn-shanghai.aliyuncs.com/"+objectName;
            FilePath = fileUrl;
            System.out.println("这是fileurl" + fileUrl);
            return Result.success(FileVO);
        } catch (IOException e) {
            log.error("上传失败");
        }

//        String uploadDir = "E:/App/";
//        // 获取文件名
//        String originalFilename = photo.getOriginalFilename();
//
//
//        try {
//            // 保存文件到服务器
//            File file = new File(uploadDir + originalFilename);
//            photo.transferTo(file);
//            // 构建图片的 URL 地址
//            String fileUrl = ServletUriComponentsBuilder.fromCurrentContextPath()
//                    .path("/admin/employee/uploads/")
//                    .path(originalFilename)
//                    .toUriString();
//
//            return Result.success(fileUrl);
//        } catch (IOException e) {
//            e.printStackTrace();
//            return Result.success("error");
//        }
        return null;
    }

    /*图片的导出与下载*/
//    @GetMapping("/uploads/{fileName:.+}")
//    public Result savaFile(@PathVariable String fileName){
//        System.out.println("这是fielname" + FilePath);
//        return Result.success(FilePath);
//    }



    /**
     * 登录
     *
     * @param employeeLoginDTO
     * @return
     */
    @PostMapping("/login")
    public Result login(@RequestBody EmployeeLoginDTO employeeLoginDTO) {
        log.info("员工登录：{}", employeeLoginDTO);

        Employee employee = employeeService.login(employeeLoginDTO);

        //登录成功后，生成jwt令牌
        /*Map<String, Object> claims = new HashMap<>();
        claims.put(JwtClaimsConstant.EMP_ID, employee.getId());
        String token = JwtUtil.createJWT(
                jwtProperties.getAdminSecretKey(),
                jwtProperties.getAdminTtl(),
                claims);

        EmployeeLoginVO employeeLoginVO = EmployeeLoginVO.builder()
                .id(employee.getId())
                .userName(employee.getUsername())
                .name(employee.getName())
                .token(token)
                .build();*/

        return Result.success(employee);
    }

    /**
     * 退出
     *
     * @return
     */
    @PostMapping("/logout")
    public Result<String> logout() {
        return Result.success();
    }

    /**
     * 根据手机号查询出该专家的已经填报的所有信息
     */
    @GetMapping("/getlandimgbyphone")
    public Result<List<landimg>> getLandimgByPhone(@RequestParam String phone){
        return Result.success(employeeService.getLandimgByPhone(phone));

    }

}
